<?php
/*
Plugin Name: Easy Banners
Plugin URI: http://www.bannersky.com/easyBanners.html
Description: manage banners
Version: 1.1
Author: bannersky
Author URI: http://www.bannersky.com/
*/

if (!class_exists("EasyBanners")){
	class EasyBanners{
		
		var $table_name = '';
		var $init = 0;
		
		function EasyBanners(){
			//constructor
			
			global $table_prefix;
	
			$this->table_name = $table_prefix."easy_banners";
		}
		function Init(){
			//create table
			if ($this->CreateBannerTable() == false){
				return false;
			}
			$this->init = 1;
			
			return true;
		}
		function addHeader() {
			echo "<script type='text/javascript' src='".get_bloginfo('wpurl')."/wp-content/plugins/easy-banners/javascript/handlers.js'></script>\n";
		}
		
		/**
		 * Creates banner table
		 */
		function CreateBannerTable() {
			
			$rs = @mysql_query("SHOW TABLES LIKE '$this->table_name'");
			$exists = @mysql_fetch_row($rs);
			if ( !$exists ) {
				$sql = "CREATE TABLE ".$this->table_name." (
						`id` int(11) NOT NULL auto_increment,      
						`name` varchar(250) default NULL,
						`imageURL` varchar(500), 
						`link` varchar(500), 
						`type` varchar(10) DEFAULT 'IMG',
						`target` varchar(10) DEFAULT '',       
						`width` smallint(6) DEFAULT 0,  
						`height` smallint(6) DEFAULT 0,
						`position` varchar(10) NOT NULL default 'RIGHT',
						PRIMARY KEY (`id`)
						);
						";
				@mysql_query($sql);
				return true;
			}
			return false;
		}
		/**
		 * insert new banner
		 */
		 function InsertBanner($name, $imageURL, $link, $type, $target, $width, $height, $position = 'RIGHT'){
		 	if (strpos($type, 'IMG') === false && strrpos($type, 'SWF') === false && strrpos($type, 'ADS') === false){
				return;
			}
			$imageURL = str_replace("'", '"', $imageURL);
			$sqlString = "INSERT INTO $this->table_name(name, imageURL, link, type, target, width, height, position)".
			             "VALUES('$name', '$imageURL', '$link', '$type', '$target', $width, $height, '$position')";
			@mysql_query($sqlString);
		 }
	 
		 /**
		 * delete from banner table
		 */
		 function DeleteBanner($id){
		 	
			$sqlString = "DELETE FROM $this->table_name WHERE id = $id";
			@mysql_query($sqlString);
		 }
		 /**
		 * update banner
		 */
		 function UpdateBanner($id, $imageURL, $link, $type, $target, $width, $height, $position = 'RIGHT'){
		 	$imageURL = str_replace("'", '"', $imageURL);
			$sqlString = "UPDATE $this->table_name SET imageURL = '$imageURL', ".
						 "link = '$link', target = '$target', width = $width, height = $height, position ='$position' WHERE id = $id";
			//echo $sqlString;
			@mysql_query($sqlString);
		 }
		 /**
		 * check banner name
		 */
		 function CheckBannerName($name){
			$sql = "SELECT COUNT(*) AS num FROM $this->table_name WHERE  name like '$name'";
			$rs = @mysql_query($sql);
			$numRS = @mysql_fetch_assoc($rs);

			if ($numRS['num'] > 0){
				return false;
			}
			return true;
		 }
		  /**
		 * check banner source url
		 */
		 function CheckBannerSource($srcURL, $is4Update = false, $oldID = 0){
		 	if ($is4Update == true){
				$sql = "SELECT COUNT(*) AS num FROM $this->table_name WHERE  imageURL like '$srcURL' AND id <> $oldID";
				//echo $sql;
			}else{
				$sql = "SELECT COUNT(*) AS num FROM $this->table_name WHERE  imageURL like '$srcURL'";
			}
			$rs = @mysql_query($sql);
			$numRS = @mysql_fetch_assoc($rs);

			if ($numRS['num'] > 0){
				return false;
			}
			return true;
		 }

		 function printAdminPage(){
			$easyBannerPath  = str_replace('\\','/',dirname(__FILE__));
		 	require_once($easyBannerPath."/php/ckurl.php");
		 	$msg = "";
		 	$task = '';
			$Error = true;
			
			
			if (isset($_POST['task'])){
				$task = $_POST['task'];
			}

			if ($task == 'INSERT_NEW' || $task == 'UPDATE_OLD'){
				$name = $_POST['name'];
				$srcURL = $_POST['srcURL'];
				$linkURL = $_POST['linkURL'];
				$openTarget = $_POST['openTarget'];
				$bannerType = $_POST['bannerType'];
				$bannerPosition = $_POST['bannerPos'];
				
				$name = trim($name);
				$name = str_replace("'", "\'", $name);
				$srcURL = trim($srcURL);
				$linkURL = trim($linkURL);
				$openTarget = trim($openTarget);
				$bannerType = trim($bannerType);
				
				
				$chk2Return = "";
				
				if ($name == ""){
					$msg .= "The Banner Name can't be NULL. ";
					$Error = false;
				}
				if ($srcURL == ""){
					$msg .= "The Banner Source URL of '$name' can't be NULL. ";
					$Error = false;
				}else if (strpos($srcURL, "'") !== false){
					$msg .= "The Banner Source URL of '$name' can't include any '. ";
					$Error = false;
				}
				if($bannerType == 'IMG'){ 
					if (function_exists(ckurl) && $_POST['checksrc'] == 1){
						if (ckurl($srcURL) == false){
							$msg .= "The Banner Source URL of '$name' is invalid. ";
							$Error = false;
						}
					}
					if ($linkURL == ""){
						$msg .= "The Link To URL of '$name' can't be NULL .";
						$Error = false;
					}else if (strpos($linkURL, "'") !== false){
						$msg .= "The Link To URL of '$name' can't include any '. ";
						$Error = false;
					}
					if (function_exists(ckurl) && $_POST['checklinkto'] == 1){
						if (ckurl($linkURL) == false){
							$msg .= "The Link To URL of '$name' is invalid. ";
							$Error = false;
						}
					}
				}else if($bannerType == 'SWF'){
					if (function_exists(ckurl)){
						if (ckurl($srcURL) == false){
							$msg .= "The Banner Source URL of '$name' is invalid. ";
							$Error = false;
						}
					}
					$linkURL = "";
				}else if ($bannerType == 'ADS'){
					if (function_exists(ckurl)  && $_POST['checksrc'] == 1){
						if (ckurl($srcURL) == false){
							$msg .= "The Banner Source URL of '$name' is invalid. ";
							$Error = false;
						}
					}
					$linkURL = "";
				}
				
				if ($Error == false){
					//
				}else{
					//check if name, srcurl exist

					if ($Error == true && $task == 'INSERT_NEW'){
						if ($this->CheckBannerName($name) == false){
							$msg .= "Insert failed. The banner name: \"$name\" existed already.";
							$Error = false;
						}
						if ($bannerType != 'ADS'){
							if ($this->CheckBannerSource($srcURL) == false){
								$msg .= "Insert failed. The source url: \"$srcURL\" existed already.";
								$Error = false;
							}
						}
						if ($Error == true){
							$this->InsertBanner($name, $srcURL, $linkURL, $chk2Return.$bannerType, $openTarget, 300, 250, $bannerPosition);
							$msg = "New banner inserted!";
						}
					}else if ($Error == true && $task == 'UPDATE_OLD'){
						$oldID = $_POST['bannerID'];
						if (is_numeric($oldID) == false){
							$msg = "Update failed. Invalid banner ID.";
							$Error = false;
						}else if ($this->CheckBannerSource($srcURL, true, $oldID) == false){
							$msg .= "Update failed. The source url: \"$srcURL\" existed already.";
							$Error = false;
						}						
						if ($Error == true){
							$this->UpdateBanner($oldID, $srcURL, $linkURL, $bannerType, $openTarget, 300, 250, $bannerPosition);
							$msg = "The banner of '$name' updated!";					
						}
					}
				}
			}else if ($task == 'DELETE_OLD'){
				$oldID = $_POST['bannerID'];
				if (is_numeric($oldID) == false){
					$msg = "Delete failed. Invalid banner ID.";
					$Error = false;
				}
				if ($Error == true){
					$sql = "SELECT * FROM $this->table_name WHERE id = $oldID";
					$rs = @mysql_query($sql);
					$row = @mysql_fetch_assoc($rs);
					$name = $row['name'];
					
					$this->DeleteBanner($oldID);
					$msg = "The banner of '$name' deleted!";					
				}
			}
			//display all
			$sql = "SELECT * FROM $this->table_name";
			$rs = @mysql_query($sql);
			?>
            <? $this->addHeader(); ?>
            <h1>Easy Banners</h1>
            <div align="center">
            	<font color="<? if($Error == false){ echo '#FF0000';} else { echo '#0000FF';} ?>">
                	<b><? echo $msg ?></b>
                </font>
                </div>
            <hr />
            <h3>Installed banners</h3>
            <p>Developed by <a href="http://www.bannersky.com" target="_blank">www.bannersky.com</a>&nbsp;&nbsp;&nbsp;&nbsp;<a href="http://www.bannersky.com/contact.php" target="_blank">Contact Us</a></p>
            <table width="80%" style="border:#E4E4E4 1px solid;">
              <tr>
                <td width="3%"  style="border-right:#E4E4E4 1px solid; padding:3px;">No.</td>
                <td width="10%"  style="border-right:#E4E4E4 1px solid; padding:3px;">Banner Name</td>
                <td width="10%"  style="border-right:#E4E4E4 1px solid; padding:3px;">Banner Type</td>
                <td width="10%"  style="border-right:#E4E4E4 1px solid; padding:3px;">Banner Position</td>
                <td width="24%" style="border-right:#E4E4E4 1px solid; padding:3px;">Banner Source URL</td>
                <td width="15%" style="border-right:#E4E4E4 1px solid; padding:3px;">Link To URL</td>
                <td width="16%" style="border-right:#E4E4E4 1px solid; padding:3px;">Open Target</td>
                <td width="14%">Action</td>
              </tr>
              <?
			  		$iItem = 0;
			  		while ( $row = @mysql_fetch_assoc($rs) ) {
						$iItem++;
			  ?>
              <form method="post" action="<?php echo $_SERVER["REQUEST_URI"]; ?>">
              <tr>
                <td style="border-top:#E4E4E4 1px solid; border-right:#E4E4E4 1px solid; padding:3px;">
					<? echo $iItem; ?>
                    <input type="hidden" name="bannerID" id="bannerID" value="<? echo $row['id']; ?>" />
                </td>
                <td style="border-top:#E4E4E4 1px solid; border-right:#E4E4E4 1px solid; padding:3px;">
					<? echo $row['name']; ?>
                    <input type="hidden" name="name" id="name" value="<? echo $row['name']; ?>" />
                </td>
                <td style="border-top:#E4E4E4 1px solid; border-right:#E4E4E4 1px solid; padding:3px;">
                	<? 
						if ($row['type'] == 'SWF'){
							echo 'Flash'; 
						}else if ($row['type'] == 'IMG'){
							echo 'Image';
						}else if ($row['type'] == 'ADS'){
							echo 'Adsense';
						}
					?>
                    <input type="hidden" name="bannerType" id="bannerType" value="<? echo $row['type']; ?>" />
                </td>
				<td style="border-top:#E4E4E4 1px solid; border-right:#E4E4E4 1px solid; padding:3px;">
                    <select name="bannerPos" id="bannerPos" autocomplete="off">
                    <option value="RIGHT"  <? if ($row['position'] == 'RIGHT') echo 'selected="selected"'; ?>>Right</option>
                    <option value="HEADER" <? if ($row['position'] == 'HEADER') echo 'selected="selected"'; ?>>Header</option>
                    <option value="LEFT" <? if ($row['position'] == 'LEFT') echo 'selected="selected"'; ?>>Left</option>
                    </select>
                </td>
                <td style="border-top:#E4E4E4 1px solid; border-right:#E4E4E4 1px solid; padding:3px;">
       <textarea name="srcURL" id="srcURL" cols="45" rows="<? if ($row['type'] == 'ADS') echo '10'; else echo '5'; ?> "><? echo trim($row['imageURL']); ?></textarea>
                </td>
                <td style="border-top:#E4E4E4 1px solid; border-right:#E4E4E4 1px solid; padding:3px;">
                	<? 
						if ($row['type'] == 'IMG'){
					?>
                	<textarea name="linkURL" id="linkURL" cols="25" rows="5"><? echo $row['link']; ?></textarea>
                    <? }else{ ?>
                    <input type="hidden" name="linkURL" id="linkURL" value="" />
                    <? } ?>
                </td>
                <td style="border-top:#E4E4E4 1px solid; border-right:#E4E4E4 1px solid; padding:3px;">
					<? if ($row['type'] == 'IMG'){ ?>
                        <select name="openTarget" id="openTarget">
                        <option value="_blank" <? if ($row['target'] == '_blank') echo 'selected="selected"'; ?>>new window</option>
                        <option value="_self" <? if ($row['target'] == '_self') echo 'selected="selected"'; ?>>same window</option>
                        </select>
                    <? }else{ ?>
                        <input type="hidden" name="openTarget" id="openTarget" value="" />
                    <? } ?>
                </td>
                <td style="border-top:#E4E4E4 1px solid; padding:3px;"><label>
                  <div align="left">
                  	<input type="hidden" name="task" id="task" value="" />
              		<input type="button" name="Update" id="Update" value="Update" onclick="this.form.task.value = 'UPDATE_OLD';this.form.submit();" style="width: 70px;"/>
             		<br />
                    <br />
                    <input type="button" name="Delete" id="Delete" value="Delete" onclick="this.form.task.value = 'DELETE_OLD';this.form.submit();"  style="width: 70px;"/>
                    </div>
                </label></td>
              </tr>
              </form>
              <?
			  		}//end of while ( $row = @mysql_fetch_assoc($rs) ) {

			  ?>
            </table>
            <br />
            <hr />
            <h3>Add New banner</h3>
            <form method="post" action="<?php echo $_SERVER["REQUEST_URI"]; ?>">
            <table width="45%" style="border:#E4E4E4 1px solid;">
              <tr>
                <td width="20%" style="border-bottom:#E4E4E4 1px solid; border-right:#E4E4E4 1px solid; padding:3px;">Banner Name</td>
                <td width="25%" style="border-bottom:#E4E4E4 1px solid; padding:3px;">
                <input type="text" name="name" id="name" size = "55" maxlength="250"/>
                </td>
              </tr>
              <tr>
                <td width="20%" style="border-bottom:#E4E4E4 1px solid; border-right:#E4E4E4 1px solid; padding:3px;">Banner Type</td>
                <td width="25%" style="border-bottom:#E4E4E4 1px solid; padding:3px;">
                <select name="bannerType" id="bannerType" onchange="onAddTypeChange(this)" autocomplete="off" >
                <option value="IMG" selected="selected">Image</option>
                <option value="SWF">Flash</option>
                <option value="ADS">Adsense</option>
                </select>
                </td>
              </tr>
              <tr>
                <td width="20%" style="border-bottom:#E4E4E4 1px solid; border-right:#E4E4E4 1px solid; padding:3px;">Banner Position</td>
                <td width="25%" style="border-bottom:#E4E4E4 1px solid; padding:3px;">
                <select name="bannerPos" id="bannerPos" autocomplete="off">
                <option value="RIGHT"  selected="selected">Right</option>
                <option value="HEADER">Header</option>
                <option value="LEFT">Left</option>
                </select>
                </td>
              </tr>
              <tr>
                <td width="20%" style="border-bottom:#E4E4E4 1px solid; border-right:#E4E4E4 1px solid; padding:3px;">Banner Source URL</td>
                <td width="25%" style="border-bottom:#E4E4E4 1px solid; padding:3px;">
                <textarea name="srcURL" id="srcURL" cols="45" rows="5"></textarea>
                </td>
              </tr>
              <tr>
                <td width="20%" style="border-bottom:#E4E4E4 1px solid; border-right:#E4E4E4 1px solid; padding:3px;">
                	<span id="checklinkSrcurlboxDescID" style="display:block">Check source url ?</span>
                </td>
                <td width="25%" style="border-bottom:#E4E4E4 1px solid; padding:3px;">
                	<span id="checklinkSrcurlboxChkID" style="display:block"><input type="checkbox" name="checksrc" id="checksrc" value="1"/></span>
                </td>
              </tr>
              <tr>
                <td width="20%" style="border-bottom:#E4E4E4 1px solid; border-right:#E4E4E4 1px solid; padding:3px;">
                	<span id="addLinkToURLDesc" style="display:block">Link To URL</span>
                </td>
                <td width="25%" style="border-bottom:#E4E4E4 1px solid; padding:3px;">
                	<span id="addLinkToURText" style="display:block"><textarea name="linkURL" id="linkURL" cols="45" rows="5"></textarea></span>
                </td>
              </tr>
              <tr>
                <td width="20%" style="border-bottom:#E4E4E4 1px solid; border-right:#E4E4E4 1px solid; padding:3px;">
                	<span id="checklinktourlboxDescID" style="display:block">Check link to url ?</span>
                </td>
                <td width="25%" style="border-bottom:#E4E4E4 1px solid; padding:3px;">
                	<span id="checklinktourlboxChkID" style="display:block"><input type="checkbox" name="checklinkto" id="checklinkto" value="1"/></span>
                </td>
              </tr>
              <tr>
                <td width="20%" style="border-bottom:#E4E4E4 1px solid; border-right:#E4E4E4 1px solid; padding:3px;">
                	<span id="addLinkToTargetDesc" style="display:block">Open Target</span>
                </td>
                <td width="25%" style="border-bottom:#E4E4E4 1px solid; padding:3px;">
               		<span id="addLinkToTargetText" style="display:block">
                    	<select name="openTarget" id="openTarget" autocomplete="off">
                    	<option value="_blank" selected="selected">new window</option>
                   	 	<option value="_self">same window</option>
                    	</select>
                	</span>
                </td>
              </tr>
              <tr>
                <td width="20%" colspan="2" style="padding:3px;">
                	<div align="center">
                    <input type="hidden" name="task" id="task" value="INSERT_NEW" />
              		<input type="Submit" name="Insert" id="Insert" value="Submit" /><br />
					</div>
                </td>
              </tr>
            </table>
            </form>
            <br />
            <br />
            <?
			
		 }//end of function
		 
	}//end of class EasyBanners{
}

if (class_exists("EasyBanners")) {
	$hl_EasyBanners = new EasyBanners();
}

//Initialize the admin panel
if (!function_exists("EasyBanners_ap")) {
	function EasyBanners_ap() {
		global $hl_EasyBanners;
		if (!isset($hl_EasyBanners)) {
			return;
		}
		if (function_exists('add_options_page')) {
			add_options_page('Easy Banners', 'Easy Banners', 9, basename(__FILE__), array(&$hl_EasyBanners, 'printAdminPage'));
		}
	}	
}
if (isset($hl_EasyBanners)) {
	add_action('admin_menu', 'EasyBanners_ap');
	add_action('activate_easy-banners/easy-banners.php', array(&$hl_EasyBanners, 'Init'));
}

if (!function_exists("wp_easy_banner_display")) {
	function wp_easy_banner_display($position = 'RIGHT', $nameOfClass='sideimg', $readMore='read more>>') {
		
		global $table_prefix;
	
		$table_name = $table_prefix."easy_banners";
		$sql = "SELECT * FROM $table_name WHERE position = '$position'";
		
		$rs = @mysql_query($sql);
		while ( $row = @mysql_fetch_assoc($rs) ) {
			$iItem++;
  		?>
<div class="<? echo $nameOfClass ?>">
		<? 
			if ($row['type'] == 'SWF'){ 
				$pos = strrpos($row['imageURL'], '.');
				if ($pos !== false){
					$title = substr($row['imageURL'], 0, $pos);
				}else{
					$title = $row['imageURL'];
				}
	   ?>
	<script type="text/javascript">
	AC_FL_RunContent( 'codebase','http://download.macromedia.com/pub/shockwave/cabs/flash/swflash.cab#version=9,0,28,0','width','300','height','250','src','<?php echo $title; ?>','quality','high','pluginspage','http://www.adobe.com/shockwave/download/download.cgi?P1_Prod_Version=ShockwaveFlash','movie','<?php echo $title; ?>' ); //end AC code
</script><noscript>
				<object classid="clsid:D27CDB6E-AE6D-11cf-96B8-444553540000" codebase="http://download.macromedia.com/pub/shockwave/cabs/flash/swflash.cab#version=9,0,28,0" width="300" height="250">
	  <param name="movie" value="<?php echo $row['imageURL']; ?>" />
	  <param name="quality" value="high" />
	  <embed src="<?php echo $row['imageURL']; ?>" quality="high" pluginspage="http://www.adobe.com/shockwave/download/download.cgi?P1_Prod_Version=ShockwaveFlash" type="application/x-shockwave-flash" width="300" height="250"></embed>
	</object>
	</noscript>
		<? }else if ($row['type'] == 'IMG') { ?>
        
			<a href="<?php echo $row['link']; ?>" target="<?php echo $row['target']; ?>"><img src="<?php echo $row['imageURL']; ?>"/></a>
            <? 
				if ($readMore != ''){
			?>
        	<p><?php echo $row['name']; ?>&nbsp;&nbsp;&nbsp;<a href="<?php echo $row['link']; ?>"><? echo $readMore ?></a></p>
            <?
				}
			?>
		<? }else if ($row['type'] == 'ADS') { ?>
        
			<?php echo $row['imageURL']; ?>
        
		<? } ?>
</div>
  <?php
		}//end of while ( $row = @mysql_fetch_assoc($rs) ) {
	}//endo of function
}

?>